SystemOrganization addCategory: #'CS520-HomeAutomation'!

RectangleMorph subclass: #RoomView
	instanceVariableNames: 'room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!RoomView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:09'!
createFromRoom: aRoom
	| newRoomView |
	newRoomView := RoomView new.
	newRoomView setRoom: aRoom.
	^ newRoomView.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 13:11'!
setLabelProperties
	| roomLabel |
	roomLabel := StringMorph new.
	roomLabel contents: room name.
	roomLabel color: (Color black orColorUnlike: self color).
	self borderColor: roomLabel color.
	self addMorphCentered: roomLabel! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:22'!
setRoom: aRoom
	room := aRoom.
	self updateViewFromModel! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:30'!
setRoomProperties
	| roomLabel |
	self width: room width.
	self height: room height.
	self color: room color.
	roomLabel := StringMorph new.
	roomLabel contents: room name.
	roomLabel color: (Color black orColorUnlike: self color).
	self borderColor: roomLabel color.
	self addMorphCentered: roomLabel! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:54'!
setViewProperties
	| roomLabel |
	self width: room width.
	self height: room height.
	self color: room color.
	roomLabel := StringMorph new.
	roomLabel contents: room name.
	roomLabel color: (Color black orColorUnlike: self color).
	self borderColor: roomLabel color.
	self addMorphCentered: roomLabel! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 13:15'!
updateViewFromModel
	self removeAllMorphs.
	self setViewProperties.
	self setLabelProperties.
	"room devices do: [ :each | self addMorphBack: (DeviceView createFromDevice: each) ]."
	! !

Object subclass: #HomeAutomationSensor
	instanceVariableNames: 'name size color room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

HomeAutomationSensor subclass: #Camera
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!Camera class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:02'!
createWithName: aName
	| newCamera |
	newCamera := Camera new.
	newCamera name: aName.
	^ newCamera.! !

!Camera methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:58'!
initialize
	self size: 20@20.
	self color: Color black.! !

!HomeAutomationSensor methodsFor: 'associating' stamp: 'CameronRieck 3/4/2013 20:56'!
attachTo: aRoom
	room := aRoom.
	aRoom addDevice: self.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:59'!
color
	^ color! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:59'!
color: aColor
	color := aColor.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 13:02'!
height
	^ size y! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 21:02'!
initialize
	name := ''.
	size := 0@0.
	color := Color white.
	room := nil.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 20:55'!
isAttachedTo: aRoom 
	^ aRoom hasDevice: self! !

!HomeAutomationSensor methodsFor: 'associating' stamp: 'CameronRieck 3/4/2013 21:00'!
isAttachedToARoom
	^ room notNil! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/28/2013 20:26'!
name 
	^ name! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/28/2013 20:25'!
name: aByteString 
	name := aByteString.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:59'!
size
	^ size! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:59'!
size: aSize
	size := aSize.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 13:02'!
width
	^ size x! !

Object subclass: #Room
	instanceVariableNames: 'roomSize attachedDevices color name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/2/2013 15:48'!
createWithSize: aPoint 
	| room |
	room := Room new.
	room setSize: aPoint.
	^ room.! !

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 11:53'!
createWithSize: aPoint withName: aName
	| room |
	room := Room new.
	room setSize: aPoint.
	room setName: aName.
	^ room.! !

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:07'!
createWithSize: aPoint withName: aName withColor: aColor
	| room |
	room := Room new.
	room setSize: aPoint.
	room setName: aName.
	room setColor: aColor.
	^ room.! !

!Room methodsFor: 'associating' stamp: 'CameronRieck 3/2/2013 15:41'!
addDevice: aDevice
	attachedDevices add: aDevice.! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:16'!
center
	^ ((self width) / 2)@((self height) / 2)! !

!Room methodsFor: 'associating' stamp: 'CameronRieck 3/3/2013 12:07'!
color
	^ color! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 11:48'!
hasDevice: aDevice
	^ attachedDevices includes: aDevice! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 12:14'!
height
	^ roomSize y! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/2/2013 15:39'!
initialize
	attachedDevices := Set new.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:58'!
length
	^ roomSize y! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:54'!
name
	^ name! !

!Room methodsFor: 'associating' stamp: 'CameronRieck 3/3/2013 12:07'!
setColor: aColor
	color := aColor.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:54'!
setName: aName
	name := aName.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/2/2013 15:35'!
setSize: aPoint 
	roomSize := aPoint.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:58'!
width
	^ roomSize x! !

TestCase subclass: #HomeAutomationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/28/2013 19:48'!
setUp! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:16'!
testAttachDeviceToRoom
	| room device |
	room := Room createWithSize: 50@100 withName: 'test' withColor: Color black.
	device := Camera new.
	device attachTo: room.
	
	self assert: (room hasDevice: device).
	self assert: (device isAttachedTo: room).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 20:59'!
testCreateCameraSensor
	| camera |
	camera := Camera createWithName: 'Camera 01'.
	self assert: (camera name = 'Camera 01').
	self assert: (camera size = (20@20)).
	self assert: (camera color = Color black).
	self assert: (camera height = 20).
	self assert: (camera width = 20).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:16'!
testCreateRoom
	| room |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	self assert: (room name = 'Kitchen').
	self assert: (room width = 50).
	self assert: (room height = 100).
	self assert: (room center = (25@50)).! !
